/**
 *    Eric Brockmeyer
 *    Spring 2011
 *
 *    Images from: http://www.frontiernet.net/~rochballparks2/towns/pgh_steps.htm
 *
 *    Using: http://bezier.de/processing/libs/xls/
 *    fjenett 20081129
 */

PFont font;

import de.bezier.data.*;  // import library, see menu "Sketch -> Import Library -> ..."

color palette1 = color(64, 1, 1);
color palette2 = color(89, 18, 2);
color palette3 = color(140, 28, 3);
color palette4 = color(166, 84, 55);
color palette5 = color(182, 146, 121);
color palette6 = color(40, 121, 184);

XlsReader reader;         // the xls reader

int [][][] stairValues = new int[45][5][8];
PImage[] thumbs = new PImage[45];
PImage[] images = new PImage[45];

Fizzy [] rustFizzy = new Fizzy [45];
Fizzy [] railFizzy = new Fizzy [45];
Fizzy [] concreteFizzy = new Fizzy [45];
Fizzy [] rebarFizzy = new Fizzy [45];
Fizzy [] plantsFizzy = new Fizzy [45];
Fizzy [] safetyFizzy = new Fizzy [45];

int [] stairTotals = new int [45];

int [] stairRustTotals = new int [45];
int [] stairBrokenRailTotals = new int [45];
int [] stairBrokenConcreteTotals = new int [45];
int [] stairRebarTotals = new int [45];
int [] stairPlantsTotals = new int [45];
int [] stairSafetyTotals = new int [45];

int hoverValue = 0;
int selectValue;
int selectFrame;
int selectState = 0;

void setup ()
{
  font = loadFont("Aharoni-Bold-48.vlw"); 
  textFont(font);
  size(1024, 500);
  for (int i = 0; i < 45; i++) {

    thumbs[i] = loadImage(str(i) + ".jpg");
    thumbs[i].resize(0,100);

    images[i] = loadImage(str(i) + ".jpg");
    images[i].resize(0,400);
  }

  reader = new XlsReader( this, "steps_final_results_clean_02.xls" );  // open xls file for reading

  reader.firstRow();              // set reader on first row, first cell
  // println( reader.getInt() );  // read data from that cell on page 1 (default, is at address 0)

  int i = 0;
  int j = 0;
  int k = 0;
  while (true) {

    stairValues[i][j][k] = reader.getInt();
    if(k < 7) {
      reader.nextCell();
      k++;
    }
    else {
      reader.nextRow();
      reader.firstCell();
      k=0;
      j++;
      if (j>=5) {
        j=0; 
        i++;
      }
    }
    if(reader.hasMoreRows() == false) {
      break;
    }
  }

  valueTotal();

  stairRustTotals = indTotal(stairRustTotals, 0);
  stairBrokenRailTotals = indTotal(stairBrokenRailTotals, 1);
  stairBrokenConcreteTotals = indTotal(stairBrokenConcreteTotals, 3);
  stairRebarTotals = indTotal(stairRebarTotals, 5);
  stairPlantsTotals = indTotal(stairPlantsTotals, 2);
  stairSafetyTotals = indTotal(stairSafetyTotals, 7);

  int rustTotal = 0;
  int railTotal = 0;
  int concreteTotal = 0;
  int rebarTotal = 0;
  int plantsTotal = 0;
  int safetyTotal = 0;

  for(int l = 0; l<45; l++) {

    rustTotal = rustTotal + stairRustTotals[l];
    railTotal = railTotal + stairBrokenRailTotals[l];
    concreteTotal = concreteTotal + stairBrokenConcreteTotals[l];
    rebarTotal = rebarTotal + stairRebarTotals[l];
    plantsTotal = plantsTotal + stairPlantsTotals[l];
    safetyTotal = safetyTotal + stairSafetyTotals[l];
    
  }

  println(stairRustTotals[0]);

  rustFizzy = setupFizzy(rustFizzy, stairRustTotals, rustTotal, 0, palette1);
  railFizzy = setupFizzy(railFizzy, stairBrokenRailTotals, railTotal, 1, palette2);
  concreteFizzy = setupFizzy(concreteFizzy, stairBrokenConcreteTotals, concreteTotal, 2, palette3);
  rebarFizzy = setupFizzy(rebarFizzy, stairRebarTotals, rebarTotal, 3, palette4);
  plantsFizzy = setupFizzy(plantsFizzy, stairPlantsTotals, plantsTotal, 4, palette5);
  safetyFizzy = setupFizzy(safetyFizzy, stairSafetyTotals, safetyTotal, 5, palette6);
  
  
  
  
}

void draw() {

  background(255);

  //testData();

  //drawTiles();
  // drawData();
  
  //moveCircles();
  drawCircles();
  
  noStroke();
  fill(palette3, 100);
  rect(0, 14, 735, 52);

  fill(255, 225);
  textSize(48);
  
  
  pushMatrix();
  translate(45, 52);
  text("pittsburgh public stairs survey", 0, 0); 
  popMatrix();
  textSize(18);
  
  fill(palette1, 150);
  text("rust", (width/6)*0.7, 400);
  
  fill(palette2, 150);
  text("broken rail", (width/6)*1.45, 400);
  
  fill(palette3, 150);
  text("broken concrete", (width/6)*2.16, 400);
  
  fill(palette4, 150);
  text("exposed rebar", (width/6)*3.1, 400);
  
  fill(palette5, 150);
  text("invasive plants", (width/6)*3.95, 400);
  
  fill(palette6, 150);
  text("safe feeling", (width/6)*4.87, 400);
  
  

  
}

  Fizzy[] setupFizzy(Fizzy arr1[], int arr2[], int total, int cat, int col) {

  for (int i = 0; i <arr1.length; i++) {

    arr1[i] = new Fizzy(arr2[i], total, cat, col);
    
  }

  return arr1;
}


void drawCircles(){
  
 for (int i = 0; i<45; i++){
  
  rustFizzy[i].draw();
  railFizzy[i].draw();
  concreteFizzy[i].draw();
  rebarFizzy[i].draw();
  plantsFizzy[i].draw();
  safetyFizzy[i].draw();
  
 } 
  
}

void moveCircles(){
  
 for (int i = 0; i<45; i++){
  
  rustFizzy[i].move();
  railFizzy[i].move();
  concreteFizzy[i].move();
  rebarFizzy[i].move();
  plantsFizzy[i].move();
  safetyFizzy[i].move();
  
 } 
  
}


//////////function for totalling all arrays

void valueTotal() {

  for (int i = 0; i<45; i++) {
    for (int j = 0; j < 5; j++) {
      for(int k = 0; k < 8; k++) {

        if ( k== 4 || k==6) {
        }
        else if ( k == 7) {
          if(stairValues[i][j][k] == 0) {
            stairTotals[i]++;
          }
        }
        else {
          stairTotals[i] = stairTotals[i] + stairValues[i][j][k];
        }
      }
    }
  }
}

//////////function for totalling array data

int[] indTotal(int arr[], int x) {

  for (int i = 0; i<45; i++) {
    for (int j = 0; j < 5; j++) {


      arr[i] = arr[i] + stairValues[i][j][x];
    }
  }

  return arr;
}


//void groupTotal(int arr[], intx){
//  
//  
//  
//  
//}


//////////test function - not usde

void testData() {

  int testValue = 0;
  for (int i = 0; i <45; i++) {
    for (int j = 0; j < 5;j++) {

      testValue = testValue + stairValues[i][j][7];
    }
  }

  println(testValue);
}

void mousePressed() {

  if (selectState == 0) {

    selectValue = int(mouseX/100)+(9*int(mouseY/100));
    selectState = 1;
    selectFrame = frameCount;
  }
  else {

    selectState = 0;
  }
}


void keyPressed(){
  
 saveFrame("eric_brockmeyer_graphic-####.jpg");

}


//------------------------------------------------FIRST INFOGRAPHIC--------------------------------------------------------------------//

//////////function for drawing background image matrix

void drawTiles() {

  for (int i = 0; i < 45; i++) {
    // images[i].resize(0,100);



    if(selectState>0) {
      tint(60, 180);
    }
    else {
      tint(150, 180);
    }

    image(thumbs[i],(i%9)*100, ((i/9)%5)*100);

    if ((int(mouseX/100)+(9*int(mouseY/100))) == i) {
      hoverValue = i;
    }
  }
  filter(BLUR,1); 
  noTint();
  if (selectState <1) {
    image(thumbs[hoverValue],(hoverValue%9)*100, ((hoverValue/9)%5)*100);
  }
}


//////////draw Data function - if photo is clicked, display its data, if clicked again return to image matrix////

void drawData() {

  if (selectState == 1) {

    tint(255, (frameCount - selectFrame)*40);
    image(images[selectValue],50, 50);

    drawBarGraphs();
  }

  else {

    for(int i = 0; i < 45; i++) {

      if (i == hoverValue) {
        stroke(palette2, 255);
      }
      else {
        stroke(palette2, 60);
      }
      strokeWeight(20);
      noFill();
      strokeCap(SQUARE);

      line((i%9)*100 + 10, ((i/9)%5)*100 + 100, (i%9)*100+10, ((i/9)%5)*100+100 - stairTotals[i]*4);

      strokeWeight(1);
      stroke(255);
      //rect((i%9)*100, ((i/9)%5)*100 +10, 20, 90);
    }
  }
}

//////////function for drawing ind image data histogram

void drawBarGraphs() {

  int graphPlacementX = 500;
  int graphPlacementY = 450;
  int graphShift = 75;
  int graphCounter = 0;
  int graphScalar = 60;
  int graphDuration = 400;


  fill(255, 150);
  pushMatrix();
  translate(graphPlacementX - 10, graphPlacementY);
  rotate(-HALF_PI);
  text("rust", 0, 0); 
  translate(0,graphShift);
  text("broken rail", 0, 0);
  translate(0,graphShift);
  text("broken concrete", 0, 0);
  translate(0,graphShift);
  text("exposed rebar", 0, 0);
  translate(0,graphShift);
  text("invasive plants", 0, 0);
  translate(0,graphShift);
  text("unsafe feel", 0, 0);
  popMatrix();

  stroke(palette4);
  strokeWeight(20);
  noFill();
  strokeCap(SQUARE);


  line(graphPlacementX + graphCounter*graphShift, graphPlacementY, graphPlacementX + graphCounter*graphShift, graphPlacementY - (stairRustTotals[selectValue]*graphScalar));
  graphCounter++;
  line(graphPlacementX + graphCounter*graphShift, graphPlacementY, graphPlacementX + graphCounter*graphShift, graphPlacementY - (stairBrokenRailTotals[selectValue]*graphScalar));
  graphCounter++;
  line(graphPlacementX + graphCounter*graphShift, graphPlacementY, graphPlacementX + graphCounter*graphShift, graphPlacementY - (stairBrokenConcreteTotals[selectValue]*graphScalar));
  graphCounter++;
  line(graphPlacementX + graphCounter*graphShift, graphPlacementY, graphPlacementX + graphCounter*graphShift, graphPlacementY - (stairRebarTotals[selectValue]*graphScalar));
  graphCounter++;
  line(graphPlacementX + graphCounter*graphShift, graphPlacementY, graphPlacementX + graphCounter*graphShift, graphPlacementY - (stairPlantsTotals[selectValue]*graphScalar));
  graphCounter++;
  line(graphPlacementX + graphCounter*graphShift, graphPlacementY, graphPlacementX + graphCounter*graphShift, graphPlacementY - ((5-stairSafetyTotals[selectValue])*graphScalar));

  //  }
}

